\ Test 20 servo PiliPlop mechanism using pseudo random numbers
\ Version for testing movements on a Hexapod, a 6 leg beatle.

hex
inside also definitions
\ : VARIABLES    create cells allot  does> @ swap cells + ;
\ : RANGE         ( u1 s1 -- u2 s2 ) 013 umin >r  100 umin  r> ;
014 variables shere
014 variables there
014 variables direction
014 variables tank
014 variables usage
    create    steps     02 allot   \ Largest distance in steps
    create    wait      02 allot   \ Wait time after each step

: PREPARE       ( -- )
    0 steps !  014 0 do
        i there @  i shere @
        2dup u<  dup 2* 1+  i direction !
        if swap then -  dup i usage !
        steps @ umax  steps !
    loop
    014 0 do  steps @ 2/  i tank !  loop ;

: ONE-STEP      ( -- )
    014 0 do
        i tank @  i usage @  -
        dup i tank !  0< if
            steps @  i tank +!
            i direction @  i shere +!
            i shere @  i servo 
        then
    loop 
    wait @ /ms ;

extra definitions ( Set protected movement speed )
: SPEED         ( u -- )        140 umin  wait ! ;
: .SPEED        ( -- )          wait @ u. ;
: (GO)          ( -- )          prepare  steps @ 0 ?do  one-step  loop ;
: B.            ( +n -- )       0 <# # # #> type space ;
: (JOINT)       ( +n s -- )     range there ! ;
: GO            ( sn .. s0 -- ) 014 0 do  i (joint)  loop  (go) ;
: JOINT         ( +n s -- )     (joint)  (go) ;
: WHERE         ( -- sn .. s0 ) 0 013 do  i shere @  -1 +loop ;
inside definitions

: SETUP-PILI    ( -- )          
    14 0 do  80  i shere !  loop
    14 0 do  80  i there !  loop
    20 wait ! ;

: .POSITION     ( -- )
    where  014 0 do b. loop space  wait @ b. ;

: MOVE-ALL      ( -- )
    015 0 do  position  loop
    2/  19 umax  A0 umin  speed
    cr .position  go  beep ;

: MOVE-FAST     ( -- )
    015 0 do  position  loop
    2/ 2/  05 umax  46 umin  speed
    cr .position  go  beep ;

forth definitions
: DEMO          ( -- )
    setup-pili  setup  beep  ( servo-on ) setup-random  06 29 c!
    begin  move-all  0f 29 *bix  key? until ;

: FASTDEMO      ( -- )
    setup-pili setup  beep  ( servo-on ) setup-random  06 29 c!
    begin  move-fast  0f 29 *bix  key? until ;

previous  forth definitions
shield piliplop\
( ' demo  to app )  freeze
    
( Einde )
